<template>
  <CRow>
    <CCol col="12" xl="8">
      <CCard>
        <CCardHeader>
          Utilisateurs
        </CCardHeader>
        <CCardBody>
          <CDataTable
            hover
            striped
            :items="users"
            :fields="fields"
            :items-per-page="5"
            clickable-rows
            :active-page="activePage"
            :pagination="{ doubleArrows: false, align: 'center'}"
            @page-change="pageChange"
            @row-clicked="rowClicked"
          >
          </CDataTable>
        </CCardBody>
      </CCard>
    </CCol>
  </CRow>
</template>

<script>
import usersData from './UsersData'
export default {
  name: 'Users',
  data () {
    return {
      users: [],
      items: this.users,
      fields: [
        { key: 'email', label: 'Email', _classes: 'font-weight-bold' },
        { key: 'company', label: 'Entreprise'},
        { key: 'job', label: 'Poste' },
        { key: 'admin', label: 'Administrateur' }
      ],
      activePage: 1
    }
  },
  watch: {
    $route: {
      immediate: true,
      handler (route) {
        if (route.query && route.query.page) {
          this.activePage = Number(route.query.page)
        }
      }
    }
  },
  methods: {
    async getAllUsers() {
      await this.$http.get("/api/users/getAllusers")
        .then(response => {
            if (response.status === 200) {
                this.users = response.data
            }
      })
    },
    getBadge (status) {
      switch (status) {
        case 'Active': return 'success'
        case 'Inactive': return 'secondary'
        case 'Pending': return 'warning'
        case 'Banned': return 'danger'
        default: 'primary'
      }
    },
    rowClicked (item, index) {
      console.log(item)
      this.$router.push({path: `users/${item._id}`})
    },
    pageChange (val) {
      this.$router.push({ query: { page: val }})
    },
  },
  beforeMount(){
    this.getAllUsers();
  }
}
</script>
